/////////////////////////////////////////////////////////////////////
// Class Creator Version 1.3.002 Copyrigth (C) Poul A. Costinsky 1994
///////////////////////////////////////////////////////////////////
// Implementation File wr_path.cpp
// class CWrPath
//
// 11/09/1994 14:01                             Author: Poul
///////////////////////////////////////////////////////////////////


#include <stdafx.h>

#include "wr_path.h"

#define new DEBUG_NEW




///////////////////////////////////////////////////////////////////
const char BASED_CODE EXE_EXTENSION[] = "exe";

///////////////////////////////////////////////////////////////////
// class CWrPath
//*****************************************************************
// Constructor
CWrPath::CWrPath()
{
        path [0] = drive[0] = dir[0] = fname [0] = fext [0] = 0;
}
//*****************************************************************
// Constructor
CWrPath::CWrPath(LPCSTR lpszPath)
{
        path [0] = 0;
        Bind (lpszPath);
}
//*****************************************************************
// Constructor
CWrPath::CWrPath(LPCSTR lpszDrive, LPCSTR lpszDir, 
                 LPCSTR lpszFName, LPCSTR lpszFExt)
{
        drive[0] = dir[0] = fname [0] = fext [0] = 0;
        Bind (lpszDrive, lpszDir, lpszFName, lpszFExt);
}
///////////////////////////////////////////////////////////////////
//*****************************************************************
inline void CWrPath::Link (LPCSTR lpszExtern, LPSTR lpszMember, int nLen)
{
        if (lpszExtern != NULL)
                {
                if (strlen (lpszExtern) >= size_t(nLen))
                        AfxThrowMemoryException();
                strcpy (lpszMember, lpszExtern);
                }
}
//*****************************************************************
void CWrPath::Bind(LPCSTR lpszPath)
{
        if (lpszPath == NULL || *lpszPath == 0 ||
            strlen (lpszPath) >= _MAX_PATH)
                AfxThrowMemoryException();
        strcpy (path, lpszPath);
        _splitpath (path, drive, dir, fname, fext);
}
//*****************************************************************
void CWrPath::Bind(LPCSTR lpszDrive, LPCSTR lpszDir, 
                 LPCSTR lpszFName, LPCSTR lpszFExt)
{
        Link (lpszDrive, drive, _MAX_DRIVE);
        Link (lpszDir  , dir  , _MAX_DIR  );
        Link (lpszFName, fname, _MAX_FNAME);
        Link (lpszFExt , fext , _MAX_EXT  );
        _makepath (path, drive, dir, fname, fext);
}

//*****************************************************************
void	CWrPath::FullPath()
{
	TCHAR buf [_MAX_PATH];
	if (_fullpath (buf, path, _MAX_PATH) == NULL)
		{
		ASSERT(0);
		return;
		}
        strcpy (path, buf);
}
/////////////////////////////////////////////////////////////////////////////
// Constructor
CWrProgramPath::CWrProgramPath()
        : CWrPath (AfxGetApp()->m_pszHelpFilePath)
{
        Link (EXE_EXTENSION, fext, _MAX_EXT);
        _makepath (path, drive, dir, fname, fext);
}
//*****************************************************************
